package Go;

// implementation class for a "list of stones";
//for porting sake this is general;
//can be implemented as Vector, Linked list, or whatever
// it's important not to have duplicates in this list!

import java.util.*;

public class ListOfStones {
   private Vector hiddenList;

   public ListOfStones() {
      hiddenList = new Vector();
   }

   public ListOfStones(Vector hiddenList) {
     this.hiddenList = hiddenList;
   }

   // check if a Stone is already in the list
   public boolean contain(GobanLocation stoneToSearch) {
      return hiddenList.contains(stoneToSearch);
   }

   // add an element to the  end of the list
   public void add(GobanLocation toAdd) {
   //3public void add(Move toAdd) {
      hiddenList.addElement(toAdd);
   }

   // get the number of elements in the list
   public int length() {
      return hiddenList.size();
   }

   //get the first element
   public GobanLocation first() {
      return (GobanLocation)hiddenList.firstElement();
   }

   // get the element in the list at the given position
   public GobanLocation getElementAt(int index) {
      return (GobanLocation)hiddenList.elementAt(index);
   }

   // delete the element in the list at the given position
   public void deleteElementAt(int index) {
      hiddenList.removeElementAt(index);
   }

   // delete the given element in the list
   public void deleteElement(GobanLocation stoneToDelete) {
   //3public void deleteElement(Move stoneToDelete) {
      hiddenList.removeElement(stoneToDelete);
   }

   public void deleteAllElements() {
     hiddenList.removeAllElements();
   }

   // get all the elements in the list
   public Enumeration getElements() {
      return hiddenList.elements();
   }

   // append another list to the end
   public void appendList(ListOfStones listToAppend) {
      for (Enumeration e = listToAppend.getElements(); e.hasMoreElements();) {

         GobanLocation currentStone = (GobanLocation)e.nextElement();

         this.add(currentStone);
      }
   }

   // set the apartenence of all the stones in the list to a given group
   public void setGroup(Group groupToSetTo) {
      for (Enumeration e = this.getElements(); e.hasMoreElements();) {
         GobanLocation currentStone = (GobanLocation)e.nextElement();
         currentStone.setGroup(groupToSetTo);
      }
   } //setGroup

   public synchronized Object clone() {
     return new ListOfStones((Vector)hiddenList.clone());
   }

   public String toString() {
     return hiddenList.toString();
   }
}