package Manager;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.Vector;

import Goban.GobanView;
import Go.*;
import Go.strategy.AtariGoEstimatorCho;

public class GoApplet extends Applet implements ActionListener{
  boolean isStandalone = false;
  BorderLayout borderLayout1 = new BorderLayout();
  Panel panel1 = new Panel();
  Panel panel2 = new Panel();
  Button btnSettings = new Button();
  Button btnStop = new Button();  
  Panel pnlGoban = new Panel();
  BorderLayout borderLayout2 = new BorderLayout();

  //Get a parameter value
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet

  public GoApplet() {
    gameManager = new GameManager();
    estimator = new AtariGoEstimatorCho();
    this.addActionListener(this);
    btnSettings.addActionListener(this);
    btnStop.addActionListener(this);
  }

//Initialize the applet

  public void init() {
    try {
    jbInit();
    }
    catch (Exception e) {
    e.printStackTrace();
    }
  }

  // ActionListener method
  public void actionPerformed(ActionEvent e) {
    if (e.getActionCommand().equals(acStart)) {

      gameManager.unregisterGobanView(gobanView);
      game = gameManager.createGame(Integer.parseInt(edtBoardSize.getText()),
                                    choiceBlackPlayerType.getSelectedItem(),
                                    choiceWhitePlayerType.getSelectedItem());

      btnSettings.setEnabled(false);
      choiceBlackPlayerType.setEnabled(false);
      choiceWhitePlayerType.setEnabled(false);
      edtBoardSize.setEnabled(false);
      lblStatusMessage.setText(smBlackThinking);

      //gobanView = new GobanView(game.goPosition);
      gobanView.setGoPosition(game.goPosition);

      gameManager.registerGobanView(gobanView);
      game.addListener(gobanView);
      game.addListener(new GoGameAdapter() {
        public void positionChanged(GoGameEvent goGameEvent) {
          if (estimator.checkPositionState(goGameEvent.getNewPosition()) == GoConstants.InProgress) {
            if (goGameEvent.getNewPosition().turn() == GoConstants.BLACK)
              lblStatusMessage.setText(smBlackThinking);
            else
              lblStatusMessage.setText(smWhiteThinking);
          }
          else if (estimator.checkPositionState(goGameEvent.getNewPosition()) == GoConstants.BlackWIN)
            lblStatusMessage.setText(smBlackWon);
          else
          if (estimator.checkPositionState(goGameEvent.getNewPosition()) == GoConstants.WhiteWIN)
            lblStatusMessage.setText(smWhiteWon);
        }
      });

      //pnlGoban.add(gobanView, BorderLayout.CENTER);

      //this.pack();
      //this.setSize(gobanView.getSize().width, this.getSize().height);
      this.setVisible(true);

      StartGameThread startGameThread = new StartGameThread();
      startGameThread.start();

      //game.playGame();
    }
    else if (e.getActionCommand().equals(acReset)) {
      gameManager.unregisterGobanView(gobanView);
      gobanView.setGoPosition(new GoPosition(Integer.parseInt(edtBoardSize.getText())));

      btnSettings.setEnabled(true);      
      btnSettings.setEnabled(true);
      choiceBlackPlayerType.setEnabled(true);
      choiceWhitePlayerType.setEnabled(true);
      edtBoardSize.setEnabled(true);

      lblStatusMessage.setText(smGameNotStarted);
    }
    else if (e.getActionCommand().equals(GameManagerConstants.FirstMove)) {
      //this.statusBar.setText("Go to beginning");
    }
    else if (e.getActionCommand().equals(GameManagerConstants.PrevMove)) {
      //this.statusBar.setText("Go to previous move");
    }
    else if (e.getActionCommand().equals(GameManagerConstants.NextMove)) {
      //this.statusBar.setText("Go to next move");
    }
    else if (e.getActionCommand().equals(GameManagerConstants.LastMove)) {
      //this.statusBar.setText("Go to last move");
    }
  }

//Component initialization

  private void jbInit() throws Exception {

    this.setLayout(borderLayout1);
    this.setSize(400,400);
    panel2.setLayout(borderLayout2);

    btnSettings.setLabel("Start game");
    btnSettings.setActionCommand(acStart);

    btnStop.setLabel("Reset");
    btnStop.setActionCommand(acReset);

    pnlGoban.setLayout(new BorderLayout());
    gobanView = new GobanView(new GoPosition(GameManagerConstants.AtariGoTableSize));
    btnWhiteSettings.setLabel("Setings");
    btnWhiteSettings.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnWhiteSettings_actionPerformed(e);
      }
    });
    btnBlackSettings.setLabel("Settings");
    btnBlackSettings.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnBlackSettings_actionPerformed(e);
      }
    });
    pnlGoban.add(gobanView, BorderLayout.CENTER);

    gridLayout1.setRows(4);
    edtBoardSize.setBackground(Color.white);
    this.add(panel1, BorderLayout.SOUTH);

    panel1.add(btnSettings, null);
    panel1.add(btnStop, null);

    this.add(panel2, BorderLayout.CENTER);
    panel2.add(pnlGoban, BorderLayout.CENTER);
    panel2.add(panel5, BorderLayout.NORTH);
    panel5.add(panel4, null);
    panel4.add(label1, null);
    panel4.add(choiceBlackPlayerType, null);
    panel4.add(btnBlackSettings, null);
    panel5.add(panel3, null);
    panel3.add(label2, null);
    panel3.add(choiceWhitePlayerType, null);
    panel3.add(btnWhiteSettings, null);
    panel5.add(panel6, null);
    panel6.add(label3, null);
    panel6.add(edtBoardSize, null);
    panel5.add(panel7, null);
    panel7.add(lblStatus, null);
    panel7.add(lblStatusMessage, null);

    label2.setText("White is ");
    label3.setText("Board size");
    edtBoardSize.setText("5");
    edtBoardSize.setColumns(2);
    label1.setText("Black is ");
    gridLayout1.setColumns(1);
    panel5.setLayout(gridLayout1);
    panel4.setLayout(flowLayout2);

    lblStatusMessage.setText(smGameNotStarted);
    lblStatus.setText("Game status: ");

    choiceBlackPlayerType.addItem(GoConstants.ptHumanPlayer);
    choiceBlackPlayerType.addItem(GoConstants.ptAlphaBetaComputerPlayer);
    choiceBlackPlayerType.addItem(GoConstants.ptGreedyComputerPlayer);
    choiceBlackPlayerType.addItem(GoConstants.ptMinMaxComputerPlayer);
    choiceBlackPlayerType.select(0);

    choiceWhitePlayerType.addItem(GoConstants.ptHumanPlayer);
    choiceWhitePlayerType.addItem(GoConstants.ptAlphaBetaComputerPlayer);    
    choiceWhitePlayerType.addItem(GoConstants.ptGreedyComputerPlayer);
    choiceWhitePlayerType.addItem(GoConstants.ptMinMaxComputerPlayer);
    choiceWhitePlayerType.select(1);
  }

//Get Applet information

  public String getAppletInfo() {
    return "Applet Information";
  }
//Get parameter info

  public String[][] getParameterInfo() {
    return null;
  }

  protected Vector listeners = new Vector();

  public void addActionListener(ActionListener l) {
    listeners.addElement(l);
  }

  public void removeActionListener(ActionListener l) {
    listeners.removeElement(l);
  }


//Main method

  public static void main(String[] args) {
    GoApplet applet = new GoApplet();
    applet.isStandalone = true;
    final Frame frame = new Frame();

    frame.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        //frame.dispose();
        System.exit(0);
      }
    });

    frame.setTitle("Applet Frame");
    frame.add(applet, BorderLayout.CENTER);
    applet.init();
    applet.start();
    frame.setSize(400,420);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((d.width - frame.getSize().width) / 2,
                      (d.height - frame.getSize().height) / 2);
    frame.setVisible(true);
  }

  class StartGameThread extends Thread {
    public void run() {
      game.playGame();
    }
  }

  private GameManager gameManager = null;
  private GoGame game = null;
  private GobanView gobanView = null;
  private AtariGoEstimatorCho estimator = null;

  private final String acStart = "Start game";
  private final String acReset = "Reset";

  private final String smGameNotStarted = "Not started yet...";
  private final String smGameOver = "Game over!";
  private final String smBlackThinking = "Black thinking...";
  private final String smWhiteThinking = "White thinking...";
  private final String smBlackWon = "Black won!";
  private final String smWhiteWon = "White won!";


  Panel panel5 = new Panel();
  Panel panel4 = new Panel();
  FlowLayout flowLayout2 = new FlowLayout();
  GridLayout gridLayout1 = new GridLayout();
  Choice choiceBlackPlayerType = new Choice();
  Label label1 = new Label();
  TextField edtBoardSize = new TextField();
  Panel panel6 = new Panel();
  Label label3 = new Label();
  Panel panel3 = new Panel();
  Choice choiceWhitePlayerType = new Choice();
  Label label2 = new Label();
  FlowLayout flowLayout1 = new FlowLayout();
  Panel panel7 = new Panel();
  Label lblStatus = new Label();
  Label lblStatusMessage = new Label();
  Button btnWhiteSettings = new Button();
  Button btnBlackSettings = new Button();

  void btnWhiteSettings_actionPerformed(ActionEvent e) {
    if (choiceWhitePlayerType.getSelectedItem().equals(GoConstants.ptAlphaBetaComputerPlayer)
        || choiceWhitePlayerType.getSelectedItem().equals(GoConstants.ptMinMaxComputerPlayer)) {

      GeneralOKCancel dialog = new MinMaxSettingsFrame(gameManager.getWhitePlayer().getStrategy());
      dialog.setVisible(true);
    }
  }

  void btnBlackSettings_actionPerformed(ActionEvent e) {
    if (choiceBlackPlayerType.getSelectedItem().equals(GoConstants.ptAlphaBetaComputerPlayer)
        || choiceBlackPlayerType.getSelectedItem().equals(GoConstants.ptMinMaxComputerPlayer)) {

      GeneralOKCancel dialog = new MinMaxSettingsFrame(gameManager.getBlackPlayer().getStrategy());
      dialog.setVisible(true);
    }
  }
}

