package Manager;

import java.awt.*;
import Go.strategy.MinMaxGoStrategy;
import Go.strategy.GoStrategy;

public class MinMaxSettingsFrame extends GeneralOKCancel {
  Label label = new Label();
  TextField textField = new TextField();
  Panel panel = new Panel();

  public MinMaxSettingsFrame(GoStrategy theStrategy) {
    try  {
      jbInit();
      //loadData();
    }
    catch (Exception e) {
      e.printStackTrace();
    }

    strategy = (MinMaxGoStrategy)theStrategy;
    loadData();
  }

  protected void jbInit() throws Exception {
    super.jbInit();

    this.add(panel, BorderLayout.CENTER);

    label.setText("Maximum Search Depth:");
    textField.setText("0");

    panel.add(label);
    panel.add(textField);
  }

  protected void loadData() {
    if (strategy != null) {
      textField.setText(new Integer(strategy.getMaxDepth()).toString());
    }
  }

  protected void saveChanges() {
    if (strategy != null) {
      try {
        int maxDepth = Integer.parseInt(textField.getText());
        strategy.setMaxDepth(maxDepth);
      }
      catch (NumberFormatException e) {}
    }
  }

  public static void main(String[] args) {
    MinMaxSettingsFrame minMaxSettingsFrame = new MinMaxSettingsFrame(null);
    minMaxSettingsFrame.setVisible(true);
  }

  protected MinMaxGoStrategy strategy = null;
}

