// Roulette-like randomly choosing a Vector's float element
// with a probability directly proportional to its value

package roulette;

import java.util.Vector;

public class Roulette {

  // this methods returns the index in chosoeFrom Vector
  // of the choosen element
  public static int rouletteChooseOne(Vector chooseFrom) {
  double Sum = 0;
  int i, length;
  double rouletteBall = 0, currentIntervalBegin = 0;

  length = chooseFrom.size();

  for (i = 0, Sum = 0; i < length; i++)
    Sum += ((Double)chooseFrom.elementAt(i)).doubleValue();

  // we generate a random double belonging to [0.0, Sum] imterval
  rouletteBall = Math.random() * Sum;

  // try to find the "lucky guy"
  currentIntervalBegin = 0;
  i = 0;

  do {
    currentIntervalBegin += ((Double)chooseFrom.elementAt(i)).doubleValue();
    i++;
  } while (currentIntervalBegin < rouletteBall);

  return (i-1);
}

  private static int rouletteChooseOneTest(Vector chooseFrom, double rouletteBall) {
  double Sum = 0;
  int i, length;
  double currentIntervalBegin = 0;

  length = chooseFrom.size();

  for (i = 0, Sum = 0; i < length; i++)
    Sum += ((Double)chooseFrom.elementAt(i)).doubleValue();

  // try to find the "lucky guy"
  currentIntervalBegin = 0;
  i = 0;

  do {
    currentIntervalBegin += ((Double)chooseFrom.elementAt(i)).doubleValue();
    i++;
  } while ((currentIntervalBegin < rouletteBall) && (i < length));

  return (i-1);
}

  public static void main(String[] args) {
    Vector list = new Vector();
    list.addElement(new Double(0.001));
    list.addElement(new Double(0.002));
    //list.addElement(new Double(0.001));
    //list.addElement(new Double(3));

    for (int i = 0; i < 30; i++)
    System.out.println(Roulette.rouletteChooseOne(list));
  }
}
